package com.fp.persistence.pgeneral.menu;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import javax.persistence.Query;

import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import com.fp.persistence.commondb.exception.CommondbException;

import java.lang.reflect.Field;
import java.util.List;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEMENUSUBLEVEL*/
@Entity(name="TgeneMenuSubLevel")
@Table(name="TGENEMENUSUBLEVEL")
public class TgeneMenuSubLevel extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneMenuSubLevel
*/
@EmbeddedId
private TgeneMenuSubLevelKey pk;
@Column(name="PRESENTATIONORDER", nullable=true)

/**
* Orden de presentacion de la agrupacion en el primer nivel del menu
*/
private Integer presentationorder;

/**Contructor por defecto*/
public TgeneMenuSubLevel(){
}
/**Contructor de TgeneMenuSubLevel
@param pPk Clave Primaria del entity
*/
public TgeneMenuSubLevel(TgeneMenuSubLevelKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneMenuSubLevel
*/
public static TgeneMenuSubLevel find(EntityManager pEntityManager,TgeneMenuSubLevelKey pKey) throws Exception{
    TgeneMenuSubLevel obj = pEntityManager.find(TgeneMenuSubLevel.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneMenuSubLevel
@return El objeto que referencia a la Clave primaria de TgeneMenuSubLevel
*/
public TgeneMenuSubLevelKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneMenuSubLevel
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneMenuSubLevel
*/
public void setPk(TgeneMenuSubLevelKey pPk){
  pk=pPk;
}
/**Obtiene el valor de presentationorder
@return valor de presentationorder*/
public Integer getPresentationorder(){
  return presentationorder;
}
/**Fija el valor de presentationorder
@param pPresentationorder nuevo Valor de presentationorder*/
public void setPresentationorder(Integer pPresentationorder){
  presentationorder=pPresentationorder;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneMenuSubLevel))return false;
    TgeneMenuSubLevel that = (TgeneMenuSubLevel) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneMenuSubLevel
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneMenuSubLevel
*/
public Object createInstance(){
 TgeneMenuSubLevel instance=new TgeneMenuSubLevel();	
 instance.setPk(new TgeneMenuSubLevelKey());
 return instance;
}
/**Clona la entidad TgeneMenuSubLevel
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneMenuSubLevel p=(TgeneMenuSubLevel)this.clone();
  p.setPk((TgeneMenuSubLevelKey)this.pk.cloneMe());
  return p;
}

	//METODOS MANUALES
	/** Sentencia que devuelve un registro de TgeneMenuSubLevel. */
	private static final String JPQL_MENU_SUB_LEVEL = "from TgeneMenuSubLevel tmsl  " + " where tmsl.pk.menucode = :menucode"
        + " and tmsl.pk.levelcode = :levelcode " + " order by tmsl.presentationorder ";
	/**
     * Metodo que entrega uns lista de definicion del menu de segundo nivel.
     * 
     * @param pMenucode Codigo de menu.
     * @param pLevel Codigo del primer nivel.
     * @return List<TgeneMenuSubLevel>
     * @throws Exception
     */
    @SuppressWarnings(com.fp.common.helper.Constant.VUNCHECKED)
    public static List<TgeneMenuSubLevel> find(EntityManager pEntityManager, Integer pMenucode, Integer pLevel) throws Exception {
        List<TgeneMenuSubLevel> lmenu = null;
        Query qry = pEntityManager.createQuery(TgeneMenuSubLevel.JPQL_MENU_SUB_LEVEL);
        qry.setParameter("menucode", pMenucode);
        qry.setParameter("levelcode", pLevel);
        lmenu = qry.getResultList();
        return lmenu;
    }
	
}
